import java.awt.Color;
import java.util.ArrayList;
import java.util.Random;

public class Salmon extends Fish
{
  private Location homeLocation;
    // location where created

  private int age;
    // number of times act has been called on this Salmon

  private static int matureAge = 4;
    // age at which a salmon becomes mature

  public Salmon(Environment env, Location loc)
  {
    super(env, loc, env.randomDirection(), Color.yellow);
    age = 0;
    homeLocation = loc;
  }

  public Salmon(Environment env, Location loc, Direction dir)
  {
    super(env, loc, dir, Color.yellow);
    age = 0;
    homeLocation = loc;
  }
        
  public Salmon(Environment env, Location loc, Direction dir, Color col)
  {
    super(env, loc, dir, col);
    age = 0;
    homeLocation = loc;
  }

  protected void generateChild(Location loc)
  {
    Salmon child = new Salmon(environment(), loc,
                                  environment().randomDirection(), color());
  }

  // returns the number of moves required to move
  // from loc to the fish's homeLocation
  private int distanceHome(Location loc)
  {
    return Math.abs(loc.row() - homeLocation.row()) +
           Math.abs(loc.col() - homeLocation.col());
  }

  
  /*** Part (a) ***/

  // a juvenile Salmon chooses its next location as if it were
  // an ordinary fish;
  // a mature salmon chooses an empty neighboring location that is
  // closer to home than this fish's current location, if one exists;
  // otherwise, it returns this fish's current location
  // postcondition: the state of this Salmon is unchanged
  protected Location nextLocation()
  {
    if (age < matureAge)
      return super.nextLocation();

    if (location().equals(homeLocation))
      return location();

    ArrayList emptyNbrs = emptyNeighbors();

    int k = 0;
    while (k < emptyNbrs.size())
    {
      Location loc = (Location)emptyNbrs.get(k);
      if (distanceHome(loc) >= distanceHome(location()))
        emptyNbrs.remove(k);
      else
        k++;
    }
    if (emptyNbrs.size() == 0)
      return location();

    Random randNumGen = RandNumGenerator.getInstance();
    int randNum = randNumGen.nextInt(emptyNbrs.size());
    return (Location) emptyNbrs.get(randNum);

/* Or: choose the first one in the list closer to home:

    for (int k = 0; k < emptyNbrs.size(); k++)
      if (distanceHome((Location)emptyNbrs.get(k)) < distanceHome(location()))
        return (Location)emptyNbrs.get(k);

    return location();
*/

  }

  /*** Part (b) ***/

  // acts for one step of the simulation
  public void act()
  {
    if (!isInEnv())
      return;

    if (age < matureAge || !location().equals(homeLocation))
      move();
    else if (breed())
      die();

    age++;
  }
}
