import java.util.*;
import java.awt.Color;

public class LightHouse extends Fish
{
	private Set visitors;
	
	public LightHouse(Environment env, Location loc)
	{
		super(env,loc);
		visitors = new HashSet();
	}

	public LightHouse(Environment env, Location loc, Direction dir)
	{
		super(env,loc,dir);
		visitors = new HashSet();
	}

	public LightHouse(Environment env, Location loc, Direction dir, Color col)
	{
		super(env,loc,dir,col);
		visitors = new HashSet();
	}
	
	public void act()
	{
		ArrayList nbrs = environment().neighborsOf(location());
		
		for(int j = 0; j < nbrs.size(); j++)
		{
			Location loc = (Location)nbrs.get(j);
			Fish f = (Fish) environment().objectAt(loc);
			if(f != null)
				visitors.add(new Integer(f.id()));	
		}
	
		System.out.println(visitors);
	}
	
	public int numVisitors()
	{
		return visitors.size();
	}
	
	
	public ArrayList visitorList()
	{
		return new ArrayList(visitors);
	}

}