public class LinkedSimpleList implements SimpleList
{
	private ListNode first;
	private ListNode last;

	/**
	 * Inserts an object at the end of the list
	 * @param o the element to be inserted into the list
	 */
	public void add(Object o)
	{
		if (first == null)
			first = last = new ListNode(o,null);
		else
		{
			last.setNext(new ListNode(o,null));
			last = last.getNext();
		}
	}
	
	/**
	 * Removes the first element of the list that is equal to o
	 * @param o the object to remove
	 */
	public void remove(Object o)
	{
		if (first != null)
		{
			if (first.getValue().equals(o))
				first = first.getNext();
			else
				for (ListNode curr = first; curr.getNext() != null; curr = curr.getNext())
					if (curr.getNext().getValue().equals(o))
					{
						if (curr.getNext() == last)
							last = curr;
						curr.setNext(curr.getNext().getNext());
						return;
					}
		}
	}
	
	/**
	 * Determine whether the list is empty.
	 * @return true if the list is empty
	 */
	public boolean isEmpty()
	{
		return first == null;
	}
	
	public String toString()
	{
		String result = "[";
		
		for (ListNode temp = first; temp != null; temp = temp.getNext())
		{
			result += temp.getValue();
			if (temp.getNext() != null)
				result += ",";
		}
		
		return result += "]";
	}			
	
	/**
	 * Obtain all of the elements in the list, as an Iterator
	 * @return an iterator over all of the elements in the list
	 */
    public java.util.Iterator iterator()
	{
		return new Elements();
	}
	
	// inner class to implement iterator over list
	class Elements implements java.util.Iterator
	{
		private ListNode curr = first;
		
		public boolean hasNext()
		{
			return curr != null;
		}

		// you want this to run in constant time
		public Object next()
		{
			Object result = null;
			
			if (hasNext())
			{
				result = curr.getValue();
				curr = curr.getNext();
				return result;
			}
			else
				throw new java.util.NoSuchElementException();
		}
		
		public void remove()
		{
			throw new UnsupportedOperationException();
		}		
    }

}
