import java.util.*;

public class SLPriorityQueue implements PriorityQueue
{
	private ArrayList pq;
	
	public SLPriorityQueue()
	{
		pq = new ArrayList();
	}
	
	public boolean isEmpty()
	{
		return pq.isEmpty();
	}
	
	public void add(Object obj)
	{
		int index = 0;
		Comparable temp = (Comparable)obj;
		while(index < pq.size() && temp.compareTo(pq.get(index)) < 0)
			index++;
		
		pq.add(index,obj);
	}
	
	public Object peekMin()
	{
		if(isEmpty()) throw new NoSuchElementException("PQ is empty");
		
		return pq.get(pq.size() - 1);  //O(1)
	}
	
	public Object removeMin()
	{
		if(isEmpty()) throw new NoSuchElementException("PQ is empty");
		
		return pq.remove(pq.size() - 1);  //O(1)
	}
	
	public String toString()
	{
		return pq.toString();
	}
}
